use lib::{client::Client, message::{Message, MessageKind}, message_read::MessageReader};
use crossterm::{
    execute,
    terminal::{
        Clear,
        ClearType,
        enable_raw_mode,
        disable_raw_mode
    },
    event::Event,
};
use tokio::io::{self, AsyncReadExt, AsyncWriteExt};

#[allow(unreachable_code)]
#[tokio::main]
pub async fn main() -> anyhow::Result<()> {
    let mut client = Client::connect("127.0.0.1", 8080).await?;
    let local_address = client.stream.local_addr()?;

    // enable_raw_mode()?;
    // execute!(
    //     std::io::stdout(),
    //     Clear(ClearType::All),
    // )?;

    let (mut rd, mut wr) = io::split(client.stream);

    let mut buf: Vec<u8> = Vec::with_capacity(4);
    let mut message_reader = MessageReader::new();

    loop {
        match rd.read_exact(&mut buf).await {
            Ok(0) => {
                println!("connection closed by server");
                continue;
            },
            Ok(n) => {
                let mut buf = Vec::with_capacity(n);
                rd.read_exact(&mut buf).await?;
                let message = message_reader.read(&buf)?;
                println!("{:?}", message);
            },
            Err(e) => eprintln!("failed reading from socket: {}", e),
        }
    }

    // loop {
    //     let n = rd.read_exact(&mut buf).await.expect("fallito lettura");

    //     if n == 0 {
    //         break;
    //     }

    //     let message =  message_reader.read(&buf)?;
    //     println!("GOT {:?}", message);

    //     let response = match &message.message_kind {
    //         MessageKind::Test => Message::new(&local_address.to_string(), MessageKind::Test, "risposta")?.as_bytes_vec()?,
    //         MessageKind::Move => todo!(),
    //         MessageKind::CreatePlayer => todo!(),
    //         MessageKind::CreateLobby => todo!(),
    //     };

    //     wr.write_all(&response.as_bytes()).await?;

    //     buf.clear();
    //     message_reader.buffer.clear();
    //     break;
    // }

    // disable_raw_mode()?;

    Ok(())
}
